LeetCode 3212. 统计X和Y出现次数相等的子矩阵数量

LeetCode 3212. 统计X和Y出现次数相等的子矩阵数量

题目描述

给你一个大小为 m x n 的二维字符矩阵 grid,矩阵中的每个字符要么是 'X',要么是 'Y',要么是 '.'。

请你统计所有以 (0,0) 为左上角、以任意格子为右下角的子矩阵中,满足以下条件的个数:

  • 子矩阵中至少包含一个 'X';
  • 子矩阵中 'X' 和 'Y' 的出现次数相等。

示例

例如:

复制代码
输入:grid = [["X","Y","."],["Y",".","X"]]
输出:3
解释:以 (0,0) 为左上角的子矩阵中,有 3 个满足条件。

(示例仅为辅助理解,具体可参考原题)

解题思路

本题要求统计所有固定左上角为原点 的子矩阵,因此我们可以利用二维前缀和 来快速计算任意从 (0,0) 到 (i,j) 的矩形区域内 'X' 和 'Y' 的数量。

算法步骤

  1. 定义三维数组 sum[m+1][n+1][2],其中 sum[i+1][j+1][0] 表示从 (0,0) 到 (i,j) 的子矩阵中 'X' 的数量,sum[i+1][j+1][1] 表示 'Y' 的数量。

  2. 遍历每个格子 (i,j),利用容斥原理更新前缀和:

    复制代码
    sum[i+1][j+1][0] = sum[i+1][j][0] + sum[i][j+1][0] - sum[i][j][0];
    sum[i+1][j+1][1] = sum[i+1][j][1] + sum[i][j+1][1] - sum[i][j][1];
  3. 如果当前格子不是 '.',根据字符的最低位增加对应计数:

    • 'X' 的 ASCII 码为 88(二进制 1011000,最低位 0);
    • 'Y' 的 ASCII 码为 89(二进制 1011001,最低位 1)。
      因此可以用 grid[i][j] & 1 来区分:值为 0 表示 'X',值为 1 表示 'Y',并将相应维度的计数加 1。
  4. 每次更新完当前 (i,j) 对应的前缀和后,立即检查从 (0,0) 到 (i,j) 的矩形是否满足条件:

    • sum[i+1][j+1][0] > 0(至少一个 'X');
    • sum[i+1][j+1][0] == sum[i+1][j+1][1](数量相等)。
      若满足,则答案 ans 加 1。
  5. 遍历结束,返回 ans。

代码实现

cpp 复制代码
class Solution {
public:
    int numberOfSubmatrices(vector<vector<char>>& grid) {
        int ans = 0, m = grid.size(), n = grid[0].size();
        // 三维前缀和,sum[i+1][j+1][0] 表示 (0,0) 到 (i,j) 的 X 数量,[1] 表示 Y 数量
        vector sum(m + 1, vector<array<int, 2>>(n + 1));
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                // 容斥原理更新前缀和
                sum[i + 1][j + 1][0] = sum[i + 1][j][0] + sum[i][j + 1][0] - sum[i][j][0];
                sum[i + 1][j + 1][1] = sum[i + 1][j][1] + sum[i][j + 1][1] - sum[i][j][1];
                // 如果当前格子不是 '.',则根据字符最低位增加对应计数
                if (grid[i][j] != '.') {
                    sum[i + 1][j + 1][grid[i][j] & 1]++;
                }
                // 检查从 (0,0) 到 (i,j) 的子矩阵是否满足条件
                if (sum[i + 1][j + 1][0] && sum[i + 1][j + 1][0] == sum[i + 1][j + 1][1]) {
                    ans++;
                }
            }
        }
        return ans;
    }
};

复杂度分析

  • 时间复杂度:O(m × n),只需遍历矩阵一次,每次更新和检查都是 O(1) 操作。
  • 空间复杂度:O(m × n),用于存储二维前缀和数组。

总结

本题利用二维前缀和快速获取子矩阵中字符的频次,并通过巧妙的位运算区分 'X' 和 'Y',代码简洁高效。注意题目要求子矩阵必须从 (0,0) 开始,因此只需枚举右下角即可。

相关推荐
信奥卷王5 小时前
[GESP202609 六级] 分树规划
算法
夏幻灵5 小时前
LeetCode 21:合并两个有序链表——双指针与哑节点详解
算法·leetcode·链表
徐小黑ACG6 小时前
Golang 基础05 结构体struct
开发语言·算法·golang
Navigator_Z7 小时前
LeetCode //C - 1286. Iterator for Combination
c语言·算法·leetcode
数智工坊7 小时前
视觉SLAM第12讲|地图构建:单目稠密重建、RGB-D点云与八叉树地图全解析
人工智能·深度学习·矩阵·机器人
北极有牛7 小时前
cpp学习笔记--常量指针
java·开发语言·算法
GPU实战笔记7 小时前
云端 GPU 训练的账户余额提醒:它能说明什么,不能说明什么?
深度学习·算法·成本管理·gpu云计算·云端训练
浮链序8 小时前
怎么证明"你这个模型是偷我的"——把蒸馏变成取证工具
算法·安全·llm
小O的算法实验室8 小时前
IEEE TMC,面向异构物联网的多目标量子行为拓扑优化算法
算法